<template>
    <v-autocomplete
        v-model="localValue"
        :items="items"
        :loading="loading"
        :search-input.sync="search"
        item-text="name"
        item-value="id"
        :filter="filterFn"
        hide-selected
        hide-no-data
        :placeholder="$t('user_placeholder', [$t('agent')])"
        prepend-inner-icon="mdi-magnify"
        outlined
    >
    </v-autocomplete>
</template>

<script>
    export default {
        name: "VSuperiorSelect",

        props: {
            value: Number
        },

        data: () => ({
            loading: false,
            items: [],
            superiors: [],
            search: null
        }),

        computed: {
            mapText() {
                if(this.items.length === 0) return;

                const result = this.items.find(i => i.name === this.search || i.email === this.search)

                return result ? result.name : '';
            },

            localValue: {
                get() {
                    return this.value;
                },

                set(val) {
                    this.$emit('input', val);
                }
            }
        },

        watch: {
            search: _.debounce(function(newVal) {
                if(!newVal) return;

                if(newVal) {
                    const item = this.items.find(i => i.name === newVal || i.email === newVal);

                    if(item) return;
                }
                this.performSearch(newVal);
            }, 500)
        },

        methods: {
            filterFn(item, queryText, itemText) {
                const caseInsensitive = queryText.toLowerCase();

                return item.email.toLowerCase().includes(caseInsensitive) ||
                    item.name.toLowerCase().includes(caseInsensitive);
            },

            performSearch(val) {
                if(this.loading) return;

                this.loading = true;

                axios
                    .get('api/affiliate/superiors', {
                        params: {
                            search: val
                        }
                    })
                    .then(({ data }) => {
                        this.loading = false;
                        this.items = data.data.filter(superior => superior.user_id !== this.localValue.id);
                    })
                    .catch(() => {
                        this.loading = false;
                    })
            }
        }
    }
</script>

<style scoped>

</style>
